# Hole to expose a USB audio card (YMMV)

import cadquery as cq

from utils import punch_hole

# The hole is for a random USB sound card.
# Consumers should set proper offsets for the hole

holes = [
    # 2-jack plug
    {
        "x": 0,
        "y": 4,
        "shape": cq.Sketch().trapezoid(17, 5, 90, mode="a").fillet(2),
    },
]


def add(
    *,
    model,
    width,
    height,
    thickness,
    offset_x,
    offset_y,
    bottom_face,
    back_face,
    shell_t
):

    # Holes
    if back_face:
        for hole in holes:
            model = punch_hole(
                model=model,
                face=back_face,
                # FIXME: This is weird because it's the RIGHT side,
                # So it's height instead of w
                # need to work on making these coherent
                w=height,
                h=thickness,
                x_offset=offset_x - 17 / 2,
                y_offset=shell_t,
                hole=hole,
                depth=shell_t,
            )

    return model
